import React from 'react';
import { ActionCollectionConfig, StateHook, StateSetter, ActionCollectionResult, StateGetter, StateChanges, StoreTools } from 'react-hooks-global-states';
export declare const createStatefulContext: <State, Metadata = null, ActionsConfig extends {} | ActionCollectionConfig<State, Metadata> = null>(initialValue: State, parameters?: Readonly<{
    /**
     * Non reactive data of the store
     * */
    metadata?: Metadata;
    /**
     * actions configuration for restricting the manipulation of the state
     */
    actions?: ActionsConfig;
    onInit?: (storeAPI: StoreTools<State, Metadata>) => void;
    onStateChanged?: (storeAPI: StoreTools<State, Metadata> & StateChanges<State>) => void;
    onSubscribed?: (storeAPI: StoreTools<State, Metadata>) => void;
    computePreventStateChange?: (storeAPI: StoreTools<State, Metadata>) => boolean;
}>) => readonly [() => [hook: StateHook<State, ActionsConfig extends null ? StateSetter<State> : ActionCollectionResult<State, Metadata, ActionsConfig>, Metadata>, stateRetriever: StateGetter<State>, stateMutator: ActionsConfig extends null ? StateSetter<State> : ActionCollectionResult<State, Metadata, ActionsConfig>], React.FC<React.PropsWithChildren<{
    initialValue?: Partial<State>;
}>>];
