import { GlobalStoreConfig } from './GlobalStore.types';
import { ActionCollectionConfig, BaseMetadata, GlobalStoreAbstract, StateChanges, StoreTools } from 'react-hooks-global-states';
export declare class GlobalStore<State, Metadata extends BaseMetadata, ActionsConfig extends ActionCollectionConfig<State, Metadata> | null | {} = null> extends GlobalStoreAbstract<State, Metadata, ActionsConfig> {
    protected config: GlobalStoreConfig<State, Metadata>;
    constructor(state: State, config?: GlobalStoreConfig<State, Metadata>, actionsConfig?: ActionsConfig);
    protected _onInitialize: ({ setState, getState, }: StoreTools<State, Metadata>) => void;
    protected _onChange: ({ getState, }: StoreTools<State, Metadata> & StateChanges<State>) => void;
    /**
     * We set it to null so the instances of the GlobalStoreAbstract can override it.
     */
    protected onInitialize: any;
    protected onChange: any;
    /**
     * Instead of calling onInitialize and onChange directly, we call the _onInitialize and _onChange
     * This allows the concat the logic of the GlobalStore with the logic of the extension class.
     */
    protected onInit: any;
    protected onStateChanged: any;
}
